//-----------------------------------------
// LScript Generic template
//
// Copyright 2007 Michael Green
// plugin@shortbutpurple.fsnet.co.uk
//

myversion=1.1;
@version 2.9
@warnings
@script generic

// global values go here
st_vmap=1;
st_even=2;
st_tool=3;

gmaps;
quicklist;
gmesh;

generic
{
	mymeshes=Scene().getSelect();
	if(!mymeshes || mymeshes[1].genus!=MESH)
		error("Please select meshes with ClothFX on them");
//debug();
	gmaps=GetSelectVmaps();

	myset[st_vmap]=1;
	myset[st_even]=1;

	reqbegin("MG Sew Points GN Ver:"+myversion);
  
    c[st_vmap] = ctlpopup("Seam Select VMap",myset[st_vmap],"MapList");
    c[st_even] = ctlpopup("Event type",myset[st_even],
					@"<none>","Cut by event","Sewing by event"@);
	t1=ctltext("Usage:","This will save a .txt file for every mesh",
						"selected with ClothFX attached in the",
						"Dynamics directory which you can then",
						"load into the ClothFX settings using",
						"Load. (NOT the Load Motion button)");
    return if !reqpost();

    for(i=1;i<=myset.size();i++)
	{
    	myset[i]=getvalue(c[i]);
	}

    reqend();
    result=SewAll(mymeshes,myset);

    if(!result)
    	error("No ClothFX found");
    infotext[1]= "ClothFX settings saved in the Dynamics directory as";
    for(i=1;i<=result.size();i++)
    {
		temp=split(result[i]);
		infotext[i+1]=temp[3]+temp[4]+",";
	}
	info(infotext);
}

SewAll:pmeshes,pset
{
	sewncount=0;
	for(i=1;i<=pmeshes.size();i++)
	{
		clothon=CheckForCloth(pmeshes[i]);
		if(clothon)
		{
			sewncount++;
			myfilename=Sew(pmeshes[i],pset);
			myfilenames[sewncount]=myfilename;
		}
	}

	SelectItem(pmeshes[1].id);
	for(i=2;i<=pmeshes.size();i++)
	{
		AddToSelection(pmeshes[i].id);
	}

	if(!sewncount)
		return(nil);
	return(myfilenames);
}

CheckForCloth:pmesh
{
	myplugin=pmesh.server(SERVER_DISPLACEMENT_H);
	i=2;
	found=0;
	while(myplugin)
	{
		if(myplugin="FX_MotionDrive")
			found=1;
		myplugin=pmesh.server(SERVER_DISPLACEMENT_H,i);
		i++;
	}
	if(found)
		return(1);
	else
		return(0);
}

GetSelectVmaps
{
	mymap=VMap(VMSELECT);
	mymaps=nil;
	i=1;
	while(mymap)
	{
    	if(mymap.type==VMSELECT)
    	{
			mymaps[i]=mymap;
			i++;
		}
		mymap=mymap.next();
	}
	return(mymaps);
}

MapList
{
	maplist[1]="<none>";
	if(gmaps==nil)
		return(maplist);
	for(i=1;i<=gmaps.size();i++)
	{
		maplist[i+1]=gmaps[i].name;
	}
	return(maplist);
}

Sew:pmesh,pset
{
//debug();
	SelectItem(pmesh.id);
	SubdivisionOrder(6);  // must be set to last for this to work
	mymap=nil;
	if(pset[st_vmap]!=1)
		mymap=gmaps[pset[st_vmap]- 1];
	myfilevalues=GetMeshLayer(pmesh);
	mylayerno=myfilevalues[1];
	mylevels=myfilevalues[3];
	SubPatchLevel(0,0);
	RefreshNow();
	mypoints=GetPoints(pmesh,mymap,mylayerno);
	matchedpoints=MatchPoints(pmesh,mypoints);
	myfilename=WriteSewingFile(pmesh,matchedpoints,myfilevalues,pset);
	SubPatchLevel(mylevels[1],mylevels[2]);
	RefreshNow();
	return(myfilename);
}

GetMeshLayer:pmesh
{
	layerno=nil;
	meshid=hex(pmesh.id);
	tempdir=getdir(TEMPDIR);
	SaveSceneCopy(tempdir+"\\MGSewPoints.lws");
	myfile=File(tempdir+"\\MGSewPoints.lws","r");
	myline=myfile.read();
	while(!myfile.eof())
	{
		if(strleft(myline,15)=="LoadObjectLayer")
		{
			myparse=parse(" ",myline);
			layerno=myparse[2].asInt();
			layerid="0x"+myparse[3];
			if(meshid==layerid)
				break;
		}
		myline=myfile.read();
	}
//	debug();
	mylevels=@3,3@;
	mylines=LookFor(myfile,"SubPatchLevel","Plugin");
	if(mylines[1]=="SubPatchLevel")
	{
		mylevels=ReadSubpatchLevel(mylines);
		mylines=LookFor(myfile,"Plugin",);
	}
	while(mylines.size()<4 || mylines[4]!="FX_MotionDrive")
	{
		mylines=LookFor(myfile,"Plugin",);
	}
	mycloth=ReadCloth(myfile);
	myfile.close();
	temp[1]=layerno;
	temp[2]=mycloth;
	temp[3]=mylevels;
	return(temp);
}


LookFor:pfile,astring,bstring="BlahBlahBlahBlah"
{
	myline=parse(" ",pfile.read());
	while(myline[1]!=astring && myline[1]!=bstring)
	{
		myline=parse(" ",pfile.read());
	}
	return(myline);
}

ReadSubpatchLevel:myline
{
	mylevels[1]=myline[2].asInt();
	mylevels[2]=myline[3].asInt();
	return(mylevels);
}

FindCloth:pfile
{
	found=parse(" ",pfile.read());
	while(found.size()<4 || found[4]!="FX_MotionDrive")
	{
		found=parse(" ",pfile.read());
	}
}

ReadCloth:pfile
{
	myline=pfile.read();
	i=1;
	while(myline!="EndPlugin")
	{
		clothset[i]=myline;
		i++;
		myline=pfile.read();
	}
	return(clothset);
}

GetPoints:pmesh,pmap=nil,player
{
	mypoints=nil;
	index=1;
	lindex=1;
	for(i=1;i<=pmesh.pointCount();i++)
	{
		mypoint=pmesh.points[i];
		if(pmesh.layer(mypoint)==player)
		{
			if(pmap&&pmap.isMapped(mypoint))
			{
				mypoints[index][1]=mypoint;
				mypoints[index][2]=lindex- 1;
				index++;
			}
			else if(!pmap)
			{
				mypoints[lindex][1]=mypoint;
				mypoints[lindex][2]=lindex- 1;
			}
			lindex++;
		}
	}
	return(mypoints);
}

MatchPoints:pmesh,ppoints
{
	quicklist=ppoints;
	gmesh=pmesh;
	qsort(1,ppoints.size());
//	CheckSort(quicklist,pmesh);
	newpoints=quicklist;
	mpind=1;
	pind=1;
	matchpoints[mpind][pind]=newpoints[1];
	for(i=2;i<=newpoints.size();i++)
	{
		currpnt=matchpoints[mpind][1];
		if(Equals(currpnt,newpoints[i],pmesh))
		{
			pind++;
			matchpoints[mpind][pind]=newpoints[i];
		}
		else
		{
			mpind++;
			matchpoints[mpind][1]=newpoints[i];
			pind=1;
		}
	}
	return(matchpoints);
}

WriteSewingFile:pmesh,ppoints,pvalues,pset
{
//debug();
	myfile=MakeSewFile(pmesh);
	WriteHeader(myfile,pvalues[2]);
	WriteSewing(myfile,ppoints,pset,pmesh);
	WriteTail(myfile,pvalues[2]);
	myfilename=myfile.name();
	myfile.close();
	return(myfilename);
}

MakeSewFile:pmesh
{
	mycontent=getdir(CONTENTDIR);
	dyndir=matchdirs(mycontent,"Dynamics");
	if(!dyndir)
	{
		chdir(mycontent);
		mkdir("Dynamics");
	}
	myname=pmesh.name;
	for(i=1;i<=myname.size();i++)
	{
		if(myname[i]==":")
			myname[i]="_";
	}
	filename=mycontent+"\\Dynamics\\"+myname+"_Sewn.txt";
	myfile=File(filename,"w");
	return(myfile);
}

WriteHeader:pfile,pvalues
{
	pfile.writeln("FX_MotionDrive");
	pfile.writeln(pvalues[1]);
	pfile.writeln(pvalues[2]);
	pfile.writeln(pvalues[3]);
}

WriteSewing:pfile,ppoints,pset,pmesh
{
	meshid=hex(pmesh.id);
	meshstr=strright(meshid,8);
	sewevent=pset[st_even]- 1;
	totallinks=0;
	for(i=1;i<=ppoints.size();i++)
	{
    	if(ppoints[i].size()<2)
    		continue;
		for(j=1;j<ppoints[i].size();j++)
    	{
			totallinks++;
			pointa=ppoints[i][j];
			pointb=ppoints[i][j+1];
         	mystr[totallinks]="1 "+pointa[2].asStr()+
			 		" "+meshstr+" "+pointb[2].asStr()
					 +" "+sewevent.asStr();
		}
	}
	pfile.writeln(totallinks.asStr());
	for(i=1;i<=mystr.size();i++)
	{
		pfile.writeln(mystr[i]);
	}
}

WriteTail:pfile,pvalues
{
	sewingstart=4;
	mypoints=pvalues[sewingstart].asInt();
	startval=sewingstart+mypoints+1;
	for(i=startval;i<=pvalues.size();i++)
	{
		pfile.writeln(pvalues[i]);
	}
}

Equals:a,b,pmesh
{
	threshold=0.005;

	apnt=a[1];
	bpnt=b[1];
	apos=pmesh.position(apnt);
	bpos=pmesh.position(bpnt);
//	if(apos-threshold<bpos && apos+threshold>bpos)
	if(apos.x==bpos.x && apos.y==bpos.y && apos.z==bpos.z)
		return(1);
	return(0);
}

CheckSort:ppoints,pmesh
{
	for(i=1;i<=ppoints.size();i++)
	{
		apnt=ppoints[i][1];
		apos=pmesh.position(apnt);
		positions[i]=apos;
	}
	debug();
}
// =======================================================
// quicksort

qsort:left,right
{
    if(right>left)
    {
        pivot=floor((right+left)/2);
        pivnew=partition(left,right,pivot);
        qsort(left,pivnew - 1);
        qsort(pivnew + 1, right);
    }
}

swap:a,b
{
    t=quicklist[a]; 
    quicklist[a]=quicklist[b];
    quicklist[b]=t; 
}

partition:left,right,pivind
{
    pivval=quicklist[pivind];
    swap(pivind,right); 
    storeind=left;
    for(i=left;i<=right - 1;i++)
    {
        if(Compare(quicklist[i],pivval))
        {
            swap(storeind,i);
            storeind++;
        }
    
    }
    swap(right,storeind);
    return(storeind);
      
}

Compare:a,b
{
	apnt=a[1];
	bpnt=b[1];
	apos=gmesh.position(apnt);
	bpos=gmesh.position(bpnt);
	if(apos.x<bpos.x)
		return(1);
	if(apos.x==bpos.x)
	{
		if(apos.y<bpos.y)
			return(1);
		if(apos.y==bpos.y)
		{
			if(apos.z<=bpos.z)
				return(1);
		}
	}

	return(0);
}
